/***************************************************************************/
/**                                                                       **/
/**                 The ORIC 48K emulator.UNIX version                    **/
/**                                                                       **/
/**                Written by JF FABRE (fabre@supaero.fr)                 **/
/**                                                                       **/
/**                This program may be freely distibuted                  **/
/**                                                                       **/
/**             as long as this header is included unmodified             **/
/**                                                                       **/
/***************************************************************************/

/* Functions evaluation program */

#include <stdio.h>
#include <math.h>
#include <float.h>
#include <string.h>

#define PAR1 1
#define PAR2 2
#define PLUS 3
#define MOIN 4
#define MULT 5
#define DIVI 6
#define PUIS 7

#define NUM 10

#define LG_CMD 100

typedef struct
{
int nature;
int operateur;
int priorite;
int valeur;
}
op;

/*** verif des parentheses ***/

int bchk(expr)
char *expr;

{
int i,np=0;

for (i=0;i<strlen(expr);i++)

 switch (expr[i])
   {
   case ')' : np--;break;
   case '(' : np++;break;
   }
 
return np;   
 
 
}

int chiffre(ch,val)

char *ch;
int *val;

{
int i,j=0,k,Base=1; /* Hexa par defaut */
char nb[30];

if (ch[0]=='!') {Base=0;ch++;j=1;}
if (ch[0]=='$') {ch++;j=1;}

for (i=0;i<strlen(ch);i++)
 {
 if (((ch[i]<'0')||(ch[i]>'9'))&&((ch[i]<'A')||(ch[i]>'F'))&&((ch[i]<'a')||(ch[i]>'f'))) break;
 nb[i]=ch[i];
 }
 
 nb[i]=0;
 
 if (val!=NULL) 
   switch(Base)
    {
    case 0 : /** entier **/
             sscanf(nb,"%d",val);break;
    case 1 : /** hexadecimal **/
             sscanf(nb,"%x",val);break;
    }
 
return i+j; 
}

op nature(ch)

char *ch;

{
op oper;

switch(ch[0])
 {
 case '(' : oper.priorite=1;oper.nature=PAR1;oper.operateur=1;break;
 case ')' : oper.priorite=1;oper.nature=PAR2;oper.operateur=1;break;
 case '+' : oper.priorite=2;oper.nature=PLUS;oper.operateur=1;break;
 case '-' : oper.priorite=2;oper.nature=MOIN;oper.operateur=1;break;
 case '*' : oper.priorite=3;oper.nature=MULT;oper.operateur=1;break;
 case '/' : oper.priorite=4;oper.nature=DIVI;oper.operateur=1;break;
/* case '^' : oper.priorite=5;oper.nature=PUIS;oper.operateur=1;break; */

 
 default  :                
            if (!chiffre(ch,&oper.valeur)) 
                        {oper.priorite=-1;break;}
            oper.priorite=0;oper.nature=NUM;oper.operateur=0;break;
 }
 
 return(oper);
}

/********* evaluation en soi **************/

long EvaluateExpression(expression,err_mess)

char *err_mess,*expression;
{
char expr[LG_CMD];
int i,spr=-1,spo=-1,fp=0,cp=0,tp=0;
op pileoper[100],fileexp[100],chai[100],pileresul[100],op1,op2;
op oper;

sprintf(expr,"(%s)",expression);


if (bchk(expr)) {sprintf(err_mess,"** Brackets error");return 0;}

pileoper[0].priorite=0;

/*** lecture de la chaine ***/

  for (i=0;i<strlen(expr);i++)

  {
  oper=nature(expr+i);
  if (oper.priorite==-1) {sprintf(err_mess,"** Syntax Error");return 0;}
  if (oper.nature==NUM)  i+=chiffre(expr+i,NULL)-1;

  chai[cp++]=oper;
  }

/*** empilement des instructions ***/

  for (i=0;i<cp;i++)

  switch (chai[i].nature)
    {
    /** operandes **/
    case NUM : fileexp[fp].valeur=chai[i].valeur;fileexp[fp].operateur=0;fileexp[fp++].nature=NUM;break;  /** valeur numerique **/
    
    case PAR1 : pileoper[++spo]=chai[i];break;
    case PAR2 : 
                while (pileoper[spo].nature!=PAR1)
                  fileexp[fp++]=pileoper[spo--];
                spo--;
                break;
    
    /** operateurs + * / etc... **/
    default :
     if ((spo>=0)&&(chai[i].priorite<=pileoper[spo].priorite))
        {
        /*** depiler ***/
        do
           fileexp[fp++]=pileoper[spo--];
        while ((spo<0)&&(chai[i].priorite>pileoper[spo].priorite));
        }
     pileoper[++spo]=chai[i]; 
      break;
    }
    
  for (i=0;i<fp;i++)
  {
  if (!fileexp[tp].operateur) pileresul[++spr]=fileexp[tp]; /* operande */        
    
    else
     {
     
     switch (fileexp[tp].nature)
     {
      case PLUS : 
                  op2=pileresul[spr--];
                  op1=pileresul[spr--];
                  pileresul[++spr].valeur=op1.valeur+op2.valeur;break;
      case MULT : 
                  op2=pileresul[spr--];
                  op1=pileresul[spr--];
                  pileresul[++spr].valeur=op1.valeur*op2.valeur;break;
      case DIVI : 
                  op2=pileresul[spr--];
                  op1=pileresul[spr--];
                  if (!op2.valeur)  {sprintf(err_mess,"** Division by 0 !!");return 0;}                   
                  pileresul[++spr].valeur=op1.valeur/op2.valeur;break;
      case MOIN : 
                  op2=pileresul[spr--];
                  op1=pileresul[spr--];                                      
                  pileresul[++spr].valeur=op1.valeur-op2.valeur;break;
/*      case PUIS : 
                  op2=pileresul[spr--];
                  op1=pileresul[spr--];                                      
                  pileresul[++spr].valeur=pow((double)op1.valeur,(double)op2.valeur);break;
*/                  
     }
     }
     
     tp++;
   }
   return(pileresul[spr].valeur);
   
}
