#define HOM_X 2
#define HOM_Y 2
#define MARGE_X 5 /* en caracteres */
#define MARGE_Y 2 /* en caracteres */
#define LARGEUR (240+2*6*MARGE_X)*HOM_X
#define HAUTEUR (224+2*8*MARGE_Y)*HOM_Y

#include "protos.h"

#include <X11/Xlib.h>
#include <X11/Xutil.h>  
#include <X11/keysym.h>

extern unsigned char *M;
extern Monitor_struct mon;
extern comm_struct cs;

ecran disp;

#ifndef SIGHUP
#define SIGHUP _SIGHUP
#endif

/****** sortir proprement de l'emulateur ******/

void ExitEmulator()

{
if (mon.TapeLoad) fclose(mon.TapeLoad);
if (mon.TapeSave) fclose(mon.TapeSave);
if (mon.printer_file) fclose(mon.printer_file);
XCloseDisplay(disp.dpy);
kill(cs.id,SIGHUP);
wait(cs.id);
exit(0);
}

/********************** Allouer une couleur **************/

int AllouerCouleur(R,G,B)

unsigned int R,G,B;

{
XColor kolor;
 
kolor.flags=DoRed|DoGreen|DoBlue;
kolor.red=R*256;
kolor.green=G*256;
kolor.blue=B*256;


if (!XAllocColor(disp.dpy,disp.cmap,&kolor)) 
   {
   printf("Pas assez de couleurs pour l'affichage\n");
   exit(1);
   }

return kolor.pixel;
}

/****** afficher un caractere sur l'ecran de l'oric ******/
/****** ca marche !!!!! **********************************/

void AfficheCaractere(unsigned char xe,unsigned char ye,
                      register unsigned char carac,contx *pgctxt,unsigned short int base_adr)

{
/* base_adr = 0xB400 pour TEXT */
/*          = 0x9800 pour HIRES */

XPoint point_fg[6*8*HOM_X*HOM_Y],point_bg[6*8*HOM_X*HOM_Y];
register int i,j,k,l,dec,xecr,yecr;
register unsigned short int mem_loc,inv_vid=0;
register unsigned int fg,bg,np_fg=0,np_bg=0;

if (carac>127) {carac-=128;inv_vid=1;}



xecr=MARGE_X+xe;
yecr=ye+MARGE_Y;  /** ynecr : no de ligne (utile pour double hauteur) **/


xecr*=6*HOM_X;  /** dimensions fenetre HP **/
yecr*=8*HOM_Y;

switch(TypeDonnee(carac))
{
case NO_ATT :


  if (carac==32) break;

  if (inv_vid) {bg=7-pgctxt->paper;fg=7-pgctxt->ink;}
          else {bg=pgctxt->paper;fg=pgctxt->ink;}
  
  mem_loc=base_adr+(((int)carac)<<3)+(((int)pgctxt->charmode)<<10) ; /* calcul de l'adresse ou est stocke */
                                           /* le bitmap du caractere */

 
 if (pgctxt->dblh)
  { 
  mem_loc+=(ye%2)<<2; 
        /* ajoute 4 a l'adresse bitmap caractere si ynecr impair */
                                                                                     
  for (j=0;j<8;j++)
    {
    dec=64; 
    for (i=0;i<6;i++)
     {
     dec>>=1;
     if (M[mem_loc]&dec) 
      {
      for (k=0;k<HOM_X;k++)
        for (l=0;l<HOM_Y;l++)
         {
          point_fg[np_fg].x=xecr+i*HOM_X+k;
          point_fg[np_fg].y=yecr+j*HOM_Y+l;
          np_fg++; 
         }
       }
      else   
      {
      for (k=0;k<HOM_X;k++)
        for (l=0;l<HOM_Y;l++)
         {
          point_bg[np_bg].x=xecr+i*HOM_X+k;
          point_bg[np_bg].y=yecr+j*HOM_Y+l;
          np_bg++;
         }
      }
     }
     if (j % 2) mem_loc++;                 
     }
  }
  else
  {
  for (j=0;j<8;j++)
    {
    dec=64; 
    for (i=0;i<6;i++)
     {
     dec>>=1;
     if (M[mem_loc]&dec) 
      {
      for (k=0;k<HOM_X;k++)
        for (l=0;l<HOM_Y;l++)
         {
          point_fg[np_fg].x=xecr+i*HOM_X+k;
          point_fg[np_fg].y=yecr+j*HOM_Y+l;
          np_fg++; 
         }
       }
      else   
      {
      for (k=0;k<HOM_X;k++)
        for (l=0;l<HOM_Y;l++)
         {
          point_bg[np_bg].x=xecr+i*HOM_X+k;
          point_bg[np_bg].y=yecr+j*HOM_Y+l;
          np_bg++;
         }
      }
     }
     mem_loc++;                 
     }
   }
  XSetForeground(disp.dpy,disp.gc,disp.coul[fg]);               
     XDrawPoints(disp.dpy,disp.fen,disp.gc,point_fg,(int)np_fg,CoordModeOrigin);

  XSetForeground(disp.dpy,disp.gc,disp.coul[bg]);               
     XDrawPoints(disp.dpy,disp.fen,disp.gc,point_bg,(int)np_bg,CoordModeOrigin);


  return;
  
  case PAPER_ATT :   
          if (inv_vid) XSetForeground(disp.dpy,disp.gc,disp.coul[9-carac]);  
                  else XSetForeground(disp.dpy,disp.gc,disp.coul[carac-16]);

          pgctxt->paper=carac-16;
          
          XFillRectangle(disp.dpy,disp.fen,disp.gc,xecr,yecr,6*HOM_X,8*HOM_Y);

  return;
    
  case INK_ATT :   
          pgctxt->ink=carac;
          break;
  
  case STD_ATT :   
  case FLASH_STD_ATT :   

          pgctxt->charmode=0;
          pgctxt->dblh=0;
          break;
  
   case ALT_ATT :   
   case FLASH_ALT_ATT :   

          pgctxt->charmode=1;
          pgctxt->dblh=0;
          break;

   case STD_DBL_HEIGHT_ATT :
   case FLASH_STD_DBL_HEIGHT_ATT :

          pgctxt->charmode=0;
          pgctxt->dblh=1;
          break;
   
   case ALT_DBL_HEIGHT_ATT :
   case FLASH_ALT_DBL_HEIGHT_ATT :

          pgctxt->charmode=1;
          pgctxt->dblh=1;
          break;

   case GFX1_ATT :
   case GFX2_ATT :
   
         mon.dispmode=HIRES;
         ClearScreen();
         break;
  
   case TEXT1_ATT :
   case TEXT2_ATT :
   
         mon.dispmode=TEXT;
         break;
  
  }
if (inv_vid) XSetForeground(disp.dpy,disp.gc,disp.coul[7-pgctxt->paper]);  
             else XSetForeground(disp.dpy,disp.gc,disp.coul[pgctxt->paper]);

XFillRectangle(disp.dpy,disp.fen,disp.gc,xecr,yecr,6*HOM_X,8*HOM_Y);


}

/****** afficher un caractere sur l'ecran hires ******/

void AfficheOctetHires(unsigned char xe,unsigned char ye,register unsigned char carac,contx *pgctxt)

{
XPoint point_fg[6*HOM_X*HOM_Y],point_bg[6*HOM_X*HOM_Y];
register int i,k,l,dec,xecr,yecr;
register unsigned int inv_vid=0,fg,bg;
register unsigned long int np_fg=0,np_bg=0;

xecr=xe;
yecr=ye;

if (yecr<201)
 {
xecr+=MARGE_X;
yecr+=8*MARGE_Y;

xecr*=6*HOM_X;  /** dimensions fenetre HP **/
yecr*=HOM_Y;

if (carac>127) {carac-=128;inv_vid=1;}

if (carac!=0x40)
{
switch(TypeDonnee(carac))
{
case NO_ATT :

  
  if (inv_vid) {bg=7-pgctxt->paper;fg=7-pgctxt->ink;}
          else {bg=pgctxt->paper;fg=pgctxt->ink;}

    if (carac>0x40) carac-=0x40; 
             
    dec=64; 
    for (i=0;i<6;i++)
     {
     dec>>=1;
     if (carac&dec) 
      {
      for (k=0;k<HOM_X;k++)
        for (l=0;l<HOM_Y;l++)
         {
          point_fg[np_fg].x=xecr+i*HOM_X+k;
          point_fg[np_fg].y=yecr+l;
          np_fg++; 
         }
       }
      else   
      {
      for (k=0;k<HOM_X;k++)
        for (l=0;l<HOM_Y;l++)
         {
          point_bg[np_bg].x=xecr+i*HOM_X+k;
          point_bg[np_bg].y=yecr+l;
          np_bg++;
         }
      }
     }

  XSetForeground(disp.dpy,disp.gc,disp.coul[fg]);               
     XDrawPoints(disp.dpy,disp.fen,disp.gc,point_fg,(int)np_fg,CoordModeOrigin);

  XSetForeground(disp.dpy,disp.gc,disp.coul[bg]);               
     XDrawPoints(disp.dpy,disp.fen,disp.gc,point_bg,(int)np_bg,CoordModeOrigin);

  return;

  case PAPER_ATT :   
          if (inv_vid) XSetForeground(disp.dpy,disp.gc,disp.coul[9-carac]);  
                  else XSetForeground(disp.dpy,disp.gc,disp.coul[carac-16]);

          pgctxt->paper=carac-16;
          
          XFillRectangle(disp.dpy,disp.fen,disp.gc,xecr,yecr,6*HOM_X,HOM_Y);
  return;
  
  case INK_ATT :   
          if (inv_vid) XSetForeground(disp.dpy,disp.gc,disp.coul[7-pgctxt->paper]);  
                  else XSetForeground(disp.dpy,disp.gc,disp.coul[pgctxt->paper]);

          pgctxt->ink=carac;
          
          XFillRectangle(disp.dpy,disp.fen,disp.gc,xecr,yecr,6*HOM_X,HOM_Y);
  break;
  
  case STD_ATT :   
  case FLASH_STD_ATT : 
  case FLASH_STD_DBL_HEIGHT_ATT : 
          pgctxt->charmode=0;
  break;
  
   case ALT_ATT :   
   case FLASH_ALT_ATT : 
   case FLASH_ALT_DBL_HEIGHT_ATT : 
          pgctxt->charmode=1;
  break;
  
  }
  }
  
  if (inv_vid) XSetForeground(disp.dpy,disp.gc,disp.coul[7-pgctxt->paper]);  
               else XSetForeground(disp.dpy,disp.gc,disp.coul[pgctxt->paper]);
  XFillRectangle(disp.dpy,disp.fen,disp.gc,xecr,yecr,6*HOM_X,HOM_Y);

 }
 else
 {

AfficheCaractere(xecr,yecr-200+24,carac,pgctxt,0x9800);
 }
  
}

/*** initialise l'ecran de l'oric ***/


void InitOricScreen(c,v)

unsigned int c;
char **v;
{
XSizeHints infos_fen;
XWMHints infos_WM;

  if (!(disp.dpy=XOpenDisplay("")))
  {
    printf("Oric Emulator : Unable to open display !\n");
    exit(1);
  }

  disp.ecr=DefaultScreen(disp.dpy);

  infos_fen.width=LARGEUR;
  infos_fen.height=HAUTEUR;
  infos_fen.min_width=LARGEUR;
  infos_fen.min_height=HAUTEUR;
  infos_fen.max_width=LARGEUR;
  infos_fen.max_height=HAUTEUR;

  infos_fen.flags=PSize | PMinSize | PMaxSize;
  infos_WM.flags=InputHint;
  infos_WM.input=True;

  disp.fen=XCreateSimpleWindow(disp.dpy,DefaultRootWindow(disp.dpy),infos_fen.x,infos_fen.y,infos_fen.width,infos_fen.height,5,
           WhitePixel(disp.dpy,disp.ecr),BlackPixel(disp.dpy,disp.ecr));

  XSetStandardProperties(disp.dpy,disp.fen,"ORIC 48K","ORIC 48K",None,v,c,&infos_fen);
  XSetWMHints(disp.dpy,disp.fen,&infos_WM);
  disp.gc=XCreateGC(disp.dpy,disp.fen,0,0);              

  /*disp.pixbuff=XCreatePixmap(disp.dpy,disp.fen,LARGEUR, HAUTEUR, 8);*/

  disp.cmap=XDefaultColormap(disp.dpy,disp.ecr);
 
  disp.coul[0]=AllouerCouleur(0,0,0);        /** noir **/
  disp.coul[1]=AllouerCouleur(255,0,0);      /** rouge **/
  disp.coul[2]=AllouerCouleur(0,255,0);      /** vert **/
  disp.coul[3]=AllouerCouleur(255,255,0);    /** jaune **/
  disp.coul[4]=AllouerCouleur(0,0,255);      /** bleu **/
  disp.coul[5]=AllouerCouleur(255,0,255);    /** magenta **/
  disp.coul[6]=AllouerCouleur(0,255,255);    /** cyan **/
  disp.coul[7]=AllouerCouleur(255,255,255);  /** blanc **/

  XMapRaised(disp.dpy,disp.fen);
 
  ClearScreen();
   
  XSelectInput(disp.dpy,disp.fen,ExposureMask);
  XSetFunction(disp.dpy,disp.gc,GXcopy);


}

/********** efface l'ecran *******************/

void ClearScreen()

{
  XSetForeground(disp.dpy,disp.gc,disp.coul[0]);
  XFillRectangle(disp.dpy,disp.fen,disp.gc,0,0,LARGEUR,HAUTEUR);
  XFlush(disp.dpy); 
  XSync(disp.dpy,0); 	 
}

/********** rafraichit le display  ***********/

void RefreshDisplay()

{
int i,olddisp;
register unsigned char k=0,j=0;

contx gctxt;

olddisp=mon.affiche;
mon.affiche=1;

if (mon.dispmode==TEXT)
  {
  for (i=0xBB80;i<0xBFE0;i+=40)
  
   {
   CurrentContext(i,k,&gctxt); 
   AfficheFinLigneText(i,k,j++,&gctxt); 
   }
  }
  else
  {
  for (i=0xA000;i<0xBFE0;i+=40)
  
   {
   CurrentContext(i,k,&gctxt); 
   AfficheFinLigneHires(i,k,j++,&gctxt); 
   }
  
  }
  
  mon.affiche=olddisp;
  XFlush(disp.dpy);
  XSync(disp.dpy,0); 	 
}


