/***************************************************************************/
/**                                                                       **/
/**                 The ORIC 48K emulator.UNIX version                    **/
/**                                                                       **/
/**                Written by JF FABRE (fabre@supaero.fr)                 **/
/**                                                                       **/
/**                This program may be freely distibuted                  **/
/**                                                                       **/
/**             as long as this header is included unmodified             **/
/**                                                                       **/
/***************************************************************************/

/* Memory storage routine and more */

#include "protos.h"

extern unsigned char *M;
extern Monitor_struct mon;

extern unsigned int PC;

CHIP8912Status_struct C8912S;

void brok()

{
}


/*** Gaule les attributs courants ***/

void CurrentContext(unsigned short int B,unsigned char X,contx *gctxt)

{
register int i;
unsigned char ich=0,pch=0,cch=0,fch=0,hch=0,mem;


if (X)
{
for (i=1;i<=X;i++)
 {
 mem=M[B-i]&0x7F;
 
 if (mem<24)
  {
  if (mem<8)
    {if (!ich) {ich=1;gctxt->ink=mem;}}
   else
   switch(mem)
       {
       case 10 : if ((!fch)&&(!cch)&&(!hch)) 
                    {cch=1;fch=1;hch=1;gctxt->charmode=0;gctxt->flash=0;gctxt->dblh=1;}
                 break;
       
       case 8  : if ((!fch)&&(!cch)) 
                    {cch=1;fch=1;gctxt->charmode=0;gctxt->flash=0;}
                 break;

       case 11 : if ((!fch)&&(!cch)&&(!hch)) 
                    {cch=1;fch=1;hch=1;gctxt->charmode=1;gctxt->flash=0;gctxt->dblh=1;}
                 break;
       
       case 9  : if ((!fch)&&(!cch)) 
                    {cch=1;fch=1;gctxt->charmode=1;gctxt->flash=0;}
                 break;

       case 14 : if ((!fch)&&(!cch)&&(!hch)) 
                    {cch=1;fch=1;hch=1;gctxt->charmode=0;gctxt->flash=1;gctxt->dblh=1;}
                 break;
       case 12 : if ((!fch)&&(!cch)) 
                    {cch=1;fch=1;gctxt->charmode=0;gctxt->flash=1;}
                 break;

       case 15 : if ((!fch)&&(!cch)&&(!hch)) 
                    {cch=1;fch=1;hch=1;gctxt->charmode=1;gctxt->flash=1;gctxt->dblh=1;}
                 break;
       case 13 : if ((!fch)&&(!cch)) 
                    {cch=1;fch=1;gctxt->charmode=1;gctxt->flash=1;}
                 break;

       
       default : if (!pch) 
                    {pch=1;gctxt->paper=mem-16;}
       }
       
     
  }
 }
}  
  if (!ich) gctxt->ink=7;      /** encre par defaut : blanc **/
  if (!pch) gctxt->paper=0;    /** papier par defaut : noir **/
  if (!cch) gctxt->charmode=0; /** charmode par defaut : standard **/
  if (!fch) gctxt->flash=0;    /** flash par defaut : non **/
  if (!hch) gctxt->dblh=0;     /** hauteur par defaut : simple **/
  
}

/*** Gaule le papier courant ***/

void CurrentPaper(unsigned short int B,unsigned char X,contx *pgctxt)

{
register int i;
unsigned char pch=0;
register unsigned char mem;


if (X)
  for (i=1;i<=X;i++)
   {
   mem=M[B-i]&0x7F;
   if ((mem>15)&&(mem<24)) 
            {pch=1;pgctxt->paper=mem-16;break;}                    
   }


  if (!pch) pgctxt->paper=0;    /** papier par defaut : noir **/
  
}

/*** renvoie le type de la donnee ***/

int TypeDonnee(unsigned char donnee)

{
if ((donnee&0x7F)>31) return NO_ATT;
if ((donnee&0x7F)<8) return INK_ATT;

switch (donnee)

 {
 case 8 : return STD_ATT;
 case 9 : return ALT_ATT;
 case 10 : return STD_DBL_HEIGHT_ATT;
 case 11 : return ALT_DBL_HEIGHT_ATT; 
 case 12 : return FLASH_STD_ATT;
 case 13 : return FLASH_ALT_ATT;
 case 14 : return FLASH_STD_DBL_HEIGHT_ATT;
 case 15 : return FLASH_ALT_DBL_HEIGHT_ATT;  
 case 26 : return TEXT1_ATT; 
 case 27 : return TEXT2_ATT; 
 case 30 : return GFX1_ATT; 
 case 31 : return GFX2_ATT; 
 }
 
return PAPER_ATT; 
}


/*** Place en memoire ***/

void Place(register unsigned char donnee,register unsigned short int B)

{
short int i;

if ((B>>8)==0x3)
  {
  /* page 3 : 6522 rhaa */

  B&=0xF0F;
  
  for (i=0;i<0x100;i+=0x10)
  M[B+i]=donnee;
  
  switch(B)
   {
   case 0x300 : 
                 if (C8912S.no_reg==0x0E)
                   {
                   /** on va tester la touche du clavier correspondant a **/
                   /** la ligne et la colonne correspondante **/
                   /** les 3 premiers bits de 0x300 contiennent le no de ligne **/

                   donnee=M[0x30F];
                                                                                
                   if (ToucheAppuyee(mon.KeyMat[(M[0x300]&0x7)][mon.corresp[donnee]]))
                      {                       
                       for (i=0x300;i<0x400;i+=0x10)
                       M[i]|=0x18;                                
                      }
                   else 
                      {
                      for (i=0x300;i<0x400;i+=0x10)
                      M[i]&=0xFF-0x18;
                      }
                      
                   /** on met le bit 4 a 1 ou a 0 selon **/

                   }
                   
                   break;
                   
                    
   case 0x30F : if (M[0x303]==0xC0) {M[0x301]|=(0xFF-0xC0);M[0x30F]|=(0xFF-0xC0);}
                else M[0x301]=donnee;
                break;
   case 0x301 : if (M[0x303]==0xC0) {M[0x301]|=(0xFF-0xC0);M[0x30F]|=(0xFF-0xC0);}
                else M[0x30F]=donnee;
                break;

   case 0x30C : 
        switch(donnee&0xEE)
        {
        case 0xCC: 
                   if (C8912S.CA2&&C8912S.CB2) 
                     {
                     C8912S.no_reg=C8912S.no_reg_req;     
                     C8912S.CA2=C8912S.CB2=0;
                     break;
                     }
                   else
                     {
                     C8912S.CA2=C8912S.CB2=0;
                     switch(C8912S.no_reg)
                       {
                       case 0xE : 
                             
                   if (ToucheAppuyee(mon.KeyMat[(M[0x300]&0x7)][mon.corresp[M[0x30F]]]))
                      {                       
                       for (i=0x300;i<0x400;i+=0x10)
                       M[i]|=0x18;                                
                      }
                   else 
                      {
                      for (i=0x300;i<0x400;i+=0x10)
                      M[i]&=0xFF-0x18;
                      }
                             break;
                             
                       default : break;
                       }                     
                     
                     }
        break;
        case 0xEE:
                    C8912S.no_reg_req=M[0x30F]&0xF;
                    C8912S.CA2=1;C8912S.CB2=1;
                    break;
        case 0xEC:
                    C8912S.CA2=0;C8912S.CB2=1;
                    break;
        }
        
                break;                  
   case 0x308 :
   case 0x309 : 
                M[0x30D]&=0xFF-0x20;break;

   case 0x30E : /*printf("PC=%x , data=%x\n",PC,donnee);*/break;
   case 0x30D : M[0x30D]&=0xFF-0x60;break;
   case 0x303 : break; 
       	
   default : /*printf("reg=%x , data=%x\n",B,donnee);*/
                break;
   } 
  return;
  }  

if (B<0xA000) {M[B]=donnee;return;}

if ((B>>14)==3) return;  /* stocke la donnee si elle n'est pas dans la ROM */

 
if (mon.dispmode==TEXT)
  {
  /** on est en TEXT **/  
  
  if ((B>0xBB7F)&&(B<0xBFE0))
    {
    /*** Ecran Texte ***/

    EcritureEcranText(donnee,B);

    return;    
    }

  if ((B>0xBFDF)&&(B<0xB500)) {M[B]=donnee; return;} /** memoire normale ici **/
  
  /** maintenant memoire definition caracteres > B500 **/
    
  
  
   
  }
  else
  {
  /** on est en HIRES **/

  if ((B>0xA000)&&(B<0xBFE0))
     {EcritureEcranHires(donnee,B);return;}
  }
  
 
    /** entre BFE0 et BFFF rien **/

M[B]=donnee;   
}

/***** Modifie la fin de la ligne en fonction des attributs courants *****/

void AfficheFinLigneText(register unsigned short int B,register unsigned char X,register unsigned char Y,contx *pgctxt)

{
register int i;

if (mon.affiche)
for (i=0;i<40-X;i++)
 AfficheCaractere(X+i,Y,M[B+i],pgctxt,0xB400);
 

}

/***** Modifie la fin de la ligne en fonction des attributs courants *****/
/***** en ne redessinant que ce qui a ete modifie par attribut *****/

void AfficheFinLigneTextPart(register unsigned short int B,register unsigned char X,
              register unsigned char Y,contx *pgctxt)

{
register int i;
char pm=0,im=0,curri,currp;

curri=pgctxt->ink;
currp=pgctxt->paper;

for (i=0;i<40-X;i++)
 {
 AfficheCaractere(X+i,Y,M[B+i],pgctxt,0xB400);
 if (curri!=pgctxt->ink) {if (pm) return; 
                          im=1;curri=pgctxt->ink;}
    else if (currp!=pgctxt->paper) {if (im) return; 
                                    pm=1;currp=pgctxt->paper;}
 }

}

/***** Modifie la fin de la ligne en fonction des attributs courants *****/
/***** en optimisant les parties a ne pas redessiner *****/

void AfficheFinLigneHiresPart(register unsigned short int B,register unsigned char X,
              register unsigned char Y,contx *pgctxt)

{
register int i;
char pm=0,im=0,curri,currp;

curri=pgctxt->ink;
currp=pgctxt->paper;

for (i=0;i<40-X;i++)
 {  
 AfficheOctetHires(X+i,Y,M[B+i],pgctxt);
 if (curri!=pgctxt->ink) {if (pm) return; 
                          im=1;curri=pgctxt->ink;}
    else if (currp!=pgctxt->paper) {if (im) return; 
                                    pm=1;currp=pgctxt->paper;}
 }
 

}

/***** Modifie la fin de la ligne en fonction des attributs courants *****/

void AfficheFinLigneHires(register unsigned short int B,register unsigned char X,
              register unsigned char Y,contx *pgctxt)

{
register int i;

if (mon.affiche)
  for (i=0;i<40-X;i++)
   {  
   AfficheOctetHires(X+i,Y,M[B+i],pgctxt);
   }
 

}
/***** ecriture ecran texte *****/


void EcritureEcranText(register unsigned char donnee,register unsigned short int B)

{
register unsigned char X,Y;
register unsigned int C;
contx gctxt;


if (M[B]==donnee) return; /** on ne touche a rien **/

C=B-0xBB80; /* coin 0,0 en 0 */
Y=C/40;   /* no de ligne   */
X=C % 40; /* no de colonne */


switch(TypeDonnee(donnee))

  {
  case NO_ATT :  

  /** on va ecrire un caractere ASCII **/
  
  CurrentContext(B,X,&gctxt); /* chope le contexte courant */
  AfficheCaractere(X,Y,donnee,&gctxt,0xB400); /* affiche le caractere */
  if ((M[B]&0x7F)>31) {M[B]=donnee;return;} /* on n'a pas ecrase un attribut */
  
  /** la on a ecrase un attribut **/
  /** il faut remettre les elts de la fin de la ligne dans le contexte courant **/
  
  M[B]=donnee;
  
  AfficheFinLigneText(B+1,X+1,Y,&gctxt);
  break;
  
  default :  
/*                 if (((donnee&0x7F)==30)||((donnee&0x7F)==31)) 
                      {
                      ClearScreen();
                      mon.dispmode=HIRES;
                      M[B]=donnee;
                      return;
                      }
*/                      
                 if ((donnee&0x7F)<8) CurrentPaper(B+1,X+1,&gctxt); 
                 M[B]=donnee;
                 AfficheCaractere(X,Y,donnee,&gctxt,0xB400);
                 CurrentContext(B+1,X+1,&gctxt); /* nouveau contexte comprenant l'encre */
                 AfficheFinLigneText(B+1,X+1,Y,&gctxt); 
                 break;

  } 



}

/***** ecriture ecran texte *****/


void EcritureEcranHires(register unsigned char donnee,register unsigned short int B)

{
register unsigned char X,Y;
register unsigned int C;
contx gctxt;


if (M[B]==donnee) return; /** on ne touche a rien **/

C=B-0xA000; /* coin 0,0 en 0 */
Y=C/40;   /* no de ligne   */
X=C % 40; /* no de colonne */


switch(TypeDonnee(donnee))

  {
  case NO_ATT :  

  /** on va ecrire un caractere ASCII **/
  
  CurrentContext(B,X,&gctxt); /* chope le contexte courant */
  AfficheOctetHires(X,Y,donnee,&gctxt); /* affiche le caractere */
  if ((M[B]&0x7F)>63)
                {M[B]=donnee;return;} /* on n'a pas ecrase un attribut */
  
  /** la on a ecrase un attribut **/
  /** il faut remettre les elts de la fin de la ligne dans le contexte courant **/
  
  M[B]=donnee;
  
  AfficheFinLigneHires(B+1,X+1,Y,&gctxt);
  break;
  
  default :  
                 if ((donnee&0x7F)<8) CurrentPaper(B+1,X+1,&gctxt); 
                 M[B]=donnee;
                 AfficheOctetHires(X,Y,donnee,&gctxt);
                 CurrentContext(B+1,X+1,&gctxt); /* nouveau contexte comprenant l'encre */
                 AfficheFinLigneHires(B+1,X+1,Y,&gctxt); 
                 break;

  } 



}
