/***************************************************************************/
/**                                                                       **/
/**                 The ORIC 48K emulator.UNIX version                    **/
/**                                                                       **/
/**                Written by JF FABRE (fabre@supaero.fr)                 **/
/**                                                                       **/
/**                This program may be freely distibuted                  **/
/**                                                                       **/
/**             as long as this header is included unmodified             **/
/**                                                                       **/
/***************************************************************************/

/* Keyboard management routines */

#include "protos.h"

extern ecran disp;
extern Monitor_struct mon;
extern unsigned char *M;


/******** initialisation du clavier **********/

void InitKeyboard()

{
FILE *f;
int i,j;
char ch[40];

 
/** lecture matrice clavier **/
 
if (!(f=fopen(mon.KeybFileName,"rt"))) 

   {
   printf("** %s : File not found\n",mon.KeybFileName);
   exit(1);
   }
  
  i=0;j=0;
   
  while(!feof(f))
  {
  fscanf(f,"%s",ch);
  if (ch[0]!='*') mon.KeyMat[i][j]=(int)ch[0];
    else
    {
    if (!strcmp(ch,"*NOK")) mon.KeyMat[i][j]=0;
    if (!strcmp(ch,"*CTL")) mon.KeyMat[i][j]=XK_Control_L;
    if (!strcmp(ch,"*ESC")) mon.KeyMat[i][j]=XK_Escape;
    if (!strcmp(ch,"*RSH")) mon.KeyMat[i][j]=XK_Shift_R;
    if (!strcmp(ch,"*LSH")) mon.KeyMat[i][j]=XK_Shift_L;
    if (!strcmp(ch,"*FCT")) mon.KeyMat[i][j]=XK_Control_R;
    if (!strcmp(ch,"*RET")) mon.KeyMat[i][j]=XK_Return;
    if (!strcmp(ch,"*DEL")) mon.KeyMat[i][j]=XK_BackSpace;
    if (!strcmp(ch,"*SPC")) mon.KeyMat[i][j]=32;
    if (!strcmp(ch,"*UAR")) mon.KeyMat[i][j]=XK_Up;
    if (!strcmp(ch,"*DAR")) mon.KeyMat[i][j]=XK_Down;
    if (!strcmp(ch,"*LAR")) mon.KeyMat[i][j]=XK_Left;
    if (!strcmp(ch,"*RAR")) mon.KeyMat[i][j]=XK_Right;
    }
    
  j++;if (j==8) {j=0;i++;if (i==8) break;}
  }
  fclose(f);

      
  /** tableau des puissances de 2 pour les colonnes du clavier **/
  
  for (i=0;i<256;i++) mon.corresp[i]=-1;
  
  mon.corresp[0xFE]=0;
  mon.corresp[0xFD]=1;
  mon.corresp[0xFB]=2;
  mon.corresp[0xF7]=3;
  mon.corresp[0xEF]=4;
  mon.corresp[0xDF]=5;
  mon.corresp[0xBF]=6;
  mon.corresp[0x7F]=7;
    
 
}

/*** attendre qu'une touche soit relachee ***/

void WaitReleased(touche)

int touche;

{
do
 {
 XQueryKeymap(disp.dpy,disp.schem_clav); /** lire le clavier **/
 }
 while(ToucheAppuyee(touche));
}


/********* Touches de controle **************/

void ControlKeys()

{  
if ( (!ToucheAppuyee(XK_Meta_L)) && (!ToucheAppuyee(XK_Alt_L)) ) 
                                  return;   

     if (ToucheAppuyee('1')) {mon.Mon_Status=USER_BREAK;return;}  /** invoquer le moniteur **/     
     if (ToucheAppuyee('2')) {mon.Mon_Status=USER_RESET1;WaitReleased('2');return;} /** invoquer le moniteur **/     
     if (ToucheAppuyee('3')) {mon.Mon_Status=USER_RESET2;WaitReleased('3');return;} /** invoquer le moniteur **/     
     if (ToucheAppuyee('4')) {mon.Mon_Status=CHANGE_TAPE;return;} /** invoquer le moniteur **/     
     if (ToucheAppuyee('5')) {WaitReleased('5');RefreshDisplay();printf("Display Refreshed...\n");return;} /** Refresh **/     
     if (ToucheAppuyee('6')) {mon.interrupt^=1;WaitReleased('6');PrintStatus("Interrupts",mon.interrupt);return;}      
     if (ToucheAppuyee('7')) {mon.sound^=1;WaitReleased('7');PrintStatus("Sound",mon.sound);return;} /** Son on/off **/
     if (ToucheAppuyee('8')) {mon.autorefresh^=1;WaitReleased('8');PrintStatus("Autorefresh",mon.autorefresh);return;} /** Rafraichissement automatique on/off **/
     if (ToucheAppuyee('9')) {
                             if (!RewindTapeLoad()) 
                                  printf("** No tape specified.\n");
                                  else printf("Load Tape rewinded.\n");
                                  WaitReleased('9');return;
                             }
     if (ToucheAppuyee('0')) {mon.affiche^=1;WaitReleased('0');PrintStatus("Autoendline",mon.affiche);if (mon.affiche) RefreshDisplay(); 
                              return;}  /** Redessine fin de ligne on/off **/     

}


/***** touche appuyee *****/

int ToucheAppuyee(c)

register unsigned long int c;
{
  KeyCode code;
  register unsigned char octet,bit;

  code=XKeysymToKeycode(disp.dpy,c);
  octet=(code>>3);
  bit=code & 7;
      
  if (1 & (disp.schem_clav[octet]>>bit))
                            return ((int)code);
  return 0;
}
