/***************************************************************************/
/**                                                                       **/
/**                 The ORIC 48K emulator.UNIX version                    **/
/**                                                                       **/
/**                Written by JF FABRE (fabre@supaero.fr)                 **/
/**                                                                       **/
/**                This program may be freely distibuted                  **/
/**                                                                       **/
/**             as long as this header is included unmodified             **/
/**                                                                       **/
/***************************************************************************/

/* Macros used in 'CPU6502.c' */

#define C_BIT 0x01
#define Z_BIT 0x02
#define I_BIT 0x04
#define D_BIT 0x08
#define B_BIT 0x10
#define V_BIT 0x40
#define N_BIT 0x80


/** Macros utilisees pour LDA,LDX,LDY,CMP,CPX,CPY,ADC,SBC,ORA,EOR **/

#define  A_IMM(fct)  {fct(M[++PC]);PC++;NC=2;return NEXT_INSTRUCTION;}
#define  A_ZRP(fct)  {fct(M[M[++PC]]);PC++;NC=3;return NEXT_INSTRUCTION;}
#define  A_ZRPX(fct) {fct(M[(M[++PC]+X)&0xff]);NC=4;PC++;return NEXT_INSTRUCTION;}
#define  A_ZRPY(fct) {fct(M[(M[++PC]+Y)&0xff]);NC=4;PC++;return NEXT_INSTRUCTION;}
#define  A_ABS(fct)  {fct(M[M[PC+1]+((unsigned short int)M[PC+2]<<8)]);NC=4;PC+=3;return NEXT_INSTRUCTION;}
#define  A_INDY(fct) {register unsigned char ADR;NC=5;ADR=M[++PC];fct(M[M[ADR]+((unsigned short int)M[ADR+1]<<8)+Y]);PC++;return NEXT_INSTRUCTION;}
#define  A_INDX(fct) {register unsigned char ADR;NC=6;ADR=M[++PC]+X;fct(M[M[ADR]+((unsigned short int)M[ADR+1]<<8)]);PC++;return NEXT_INSTRUCTION;}
#define  A_ABSX(fct) {fct(M[M[PC+1]+((unsigned short int)M[PC+2]<<8)+X]);NC=4;PC+=3;return NEXT_INSTRUCTION;}
#define  A_ABSY(fct) {fct(M[M[PC+1]+((unsigned short int)M[PC+2]<<8)+Y]);NC=4;PC+=3;return NEXT_INSTRUCTION;}

#define  CLx(b) {P&=(0xFF-b);PC++;NC=2;return NEXT_INSTRUCTION;}
#define  SEx(b) {P|=b;PC++;NC=2;return NEXT_INSTRUCTION;}

#define  Txx(s,d) {d=s;PC++;TestNZ(d);NC=2;return NEXT_INSTRUCTION;}

#define  LDx(s) {s=B;TestNZ(s);}

#define  TestNZ(v) {P&=(0xFF-Z_BIT-N_BIT);if (v&0x80) P|=N_BIT; else if (!v) P|=Z_BIT;}

/*
#define  BxV(tbit) {char DJ;PC++;NC=2;if (P&tbit) { DJ=(char)M[PC]; if (((PC&0xFF)+DJ)&0x100) NC++; PC+=DJ+1;NC++;return NEXT_INSTRUCTION;} PC++;return NEXT_INSTRUCTION;}
#define  BxF(tbit) {char DJ;PC++;NC=2;if (!(P&tbit)) { DJ=(char)M[PC]; if (((PC&0xFF)+DJ)&0x100) NC++; PC+=DJ+1;NC++;return NEXT_INSTRUCTION;} PC++;return NEXT_INSTRUCTION;}
*/

#define  BRANCH()  {DJ=M[PC];if (DJ&0x80) PC-=(DJ^0xFF); else PC+=DJ+1;}
#define  BxV(tbit) {PC++;NC=3;if (P&tbit) {unsigned char DJ;BRANCH();return NEXT_INSTRUCTION;} PC++;return NEXT_INSTRUCTION;}
#define  BxF(tbit) {PC++;NC=3;if (!(P&tbit)) {unsigned char DJ;BRANCH();return NEXT_INSTRUCTION;} PC++;return NEXT_INSTRUCTION;}
