#include "protos.h"


extern unsigned short int PC;
extern unsigned char S,X,A,Y,P;
extern unsigned char *M;

extern Monitor_struct mon;


/****** evaluer une expression *******/

void PrintExpression(ch)

char *ch;

{
char err_mess[LG_CMD]="";
int resultat;

resultat=EvaluateExpression(ch,err_mess);

if (err_mess[0]) 
   {
   printf("%s\n",err_mess);
   return;
   }

printf("            | ");
PrintAddress((unsigned short int)resultat);
printf(" | !%d | ",resultat);
PrintBinary((unsigned long int)resultat);
putchar('\n');

}

/***********************************/

int LireOctet(c)

unsigned char *c;

{
if (mon.TapeLoadName[0]=='\n') return 0;

if (feof(mon.TapeLoad)) return 2;

*c=fgetc(mon.TapeLoad);

return 1;
}

/***********************************/

int EcrireOctet(c)

unsigned char c;

{
if (mon.TapeSaveName[0]=='\n') return 0;

if (!mon.TapeSave) return 0;


fputc(c,mon.TapeSave);

return 1;
}


/*****************************************/
/**** place un element dans une liste ****/
/*****************************************/

int AddElt(unsigned short int bpaddr,
           unsigned short int *liste,unsigned char *liste2,int *pnbelts)

{
if (*pnbelts>N_MAX_BREAKPOINTS) return 0;

liste[*pnbelts]=bpaddr;
liste2[(*pnbelts)++]=M[bpaddr];

return 1;
}

/**** supprime un element dans une liste ****/

int RemoveElt(unsigned short int bpaddr,unsigned short int *liste,int *pnbelts)

{
int i,j;

i=TestEltValid(bpaddr,liste,pnbelts);
if (!i) return 0;

liste[*pnbelts]=0; /* valeur nulle (par securite) */

for (j=i-1;j<*pnbelts;j++)
   liste[j]=liste[j+1]; 

(*pnbelts)--;

return 1;
}

/*** teste si l'ement appartient a la liste ****/

int TestEltValid(unsigned short int bpaddr,unsigned short int *liste,int *pnbelts)

{
int i;

if (!*pnbelts) return 0; /* pas de breakpoints */

for (i=0;i<*pnbelts;i++)
 
 if (liste[i]==bpaddr) break;
 
if (i==*pnbelts) return 0; /* pas trouve dans la liste */

return (i+1);

}

/************* partie specifique aux breakpoints **************/

/*** active les breakpoints a la sortie du moniteur ***/

void SetBreakpointsActive()

{ 
int i;

if (!mon.nb_break) return;

for (i=0;i<mon.nb_break;i++)
   M[mon.BreakPointList[i]]=0x17; /* code illegal declenchant un breakpoint */
 

}

/*** desactive les breakpoints lors de l'entree dans le moniteur ***/

void SetBreakpointsInactive()

{ 
int i;

if (!mon.nb_break) return;

for (i=0;i<mon.nb_break;i++)
   M[mon.BreakPointList[i]]=mon.BreakPointMem[i]; /* restauration des vrais codes */
 

}

/**** liste les breakpoints ****/

void ListBreakpoints()

{
int i;

if (!mon.nb_break) {printf("No breakpoints\n");return;}

printf("List of breakpoints :\n");

for (i=0;i<mon.nb_break;i++)
 {PrintAddress(mon.BreakPointList[i]);putchar('\n');}

putchar('\n');
}

/**** efface tous les breakpoints ****/

void DeleteBreakpoints()

{
mon.nb_break=0;
}

/**** place un point d'arret ****/

int AddBreakPoint(unsigned short int bpaddr)

{
return(AddElt(bpaddr,mon.BreakPointList,mon.BreakPointMem,&mon.nb_break));
}

/**** supprime un point d'arret ****/

int RemoveBreakPoint(unsigned short int bpaddr)

{
return(RemoveElt(bpaddr,mon.BreakPointList,&mon.nb_break));
}

/*** teste si c'est vraiment un breakpoint ****/

int TestBreakpointValid(unsigned short int bpaddr)

{
return(TestEltValid(bpaddr,mon.BreakPointList,&mon.nb_break));
}

/************* partie specifique aux memwatches **************/

/**** efface tous les mwRM ****/

void DeleteMemWatchesRM()

{
mon.nb_mwRM=0;
}

/**** efface tous les mwWM ****/

void DeleteMemWatchesWM()

{
mon.nb_mwWM=0;
}

/****** MemWatch ******/

void ListMemWatchesRM()

{
int i;

if (!mon.nb_mwRM) {printf("No memwatches in read mode\n");return;}

printf("List of memwatches in read mode :\n");

for (i=0;i<mon.nb_mwRM;i++)
 {PrintAddress(mon.MemWatchRMList[i]);putchar('\n');}

putchar('\n');
}


/****** MemWatch ******/

void ListMemWatchesWM()

{
int i;

if (!mon.nb_break) {printf("No memwatches in write mode\n");return;}

printf("List of memwatches in write mode :\n");

for (i=0;i<mon.nb_mwWM;i++)
 {PrintAddress(mon.MemWatchWMList[i]);putchar('\n');}

putchar('\n');
}

/*** teste si c'est vraiment un mwWM ****/

int TestMemWatchWMValid(unsigned short int bpaddr)

{
return(TestEltValid(bpaddr,mon.MemWatchWMList,&mon.nb_mwWM));
}

/*** teste si c'est vraiment un mwRM ****/

int TestMemWatchRMValid(unsigned short int bpaddr)

{
return(TestEltValid(bpaddr,mon.MemWatchRMList,&mon.nb_mwRM));
}

/**** place un mwRM ****/

int AddMemWatchRM(unsigned short int bpaddr)

{
return(AddElt(bpaddr,mon.MemWatchRMList,mon.MemWatchRMMem,&mon.nb_mwRM));
}

/**** supprime un mwRM ****/

int RemoveMemWatchRM(unsigned short int bpaddr)

{
return(RemoveElt(bpaddr,mon.MemWatchRMList,&mon.nb_mwRM));
}

/**** place un mwWM ****/

int AddMemWatchWM(unsigned short int bpaddr)

{
return(AddElt(bpaddr,mon.MemWatchWMList,mon.MemWatchWMMem,&mon.nb_mwWM));
}

/**** supprime un mwWM ****/

int RemoveMemWatchWM(unsigned short int bpaddr)

{
return(RemoveElt(bpaddr,mon.MemWatchWMList,&mon.nb_mwWM));
}

/****** renvoie le programme appelant **********/

unsigned short int Caller()

{
return ((unsigned short int)M[STACK_BEGIN+S]+(((unsigned short int)M[STACK_BEGIN+S+1])<<8)-2);
}

/****** change la K7 ********/

void ChangeTapeLoad(char *ch3)

{
char ch[40],ch2[200];
FILE *f;

if (ch3[0]!='\0') strcpy(ch,ch3);

  else
  
  {
  printf("Type in new load tape name : ");fflush(stdout);
  gets(ch);

  if (mon.BreakReq)
        {
        mon.BreakReq=0;
        printf("** Not done\n");
        return;
        }
  }
  
fclose(mon.TapeLoad);

sprintf(ch2,"%s/%s",mon.TapeDir,ch);

if ((!(f=fopen(ch2,"rb")))||(ch2[0]=='\0')) 
      {
      printf("** Tape not found in directory !\n");
      mon.TapeLoad=NULL;
      return;
      }

strcpy(mon.TapeLoadName,ch);
fclose(f);fclose(mon.TapeLoad);
printf("Current load tape is now %s\n",mon.TapeLoadName);

mon.TapeLoad=fopen(ch2,"rb");
 
}       

/****** change la K7 ********/

void ChangeTapeSave(char *ch3)

{
char ch[40],ch2[200];
FILE *f;

if (ch3[0]!='\0') strcpy(ch,ch3);

  else
  
  {
  printf("Type in new save tape name : ");fflush(stdout);
  gets(ch);

  if (mon.BreakReq)
        {
        mon.BreakReq=0;
        printf("** Not done\n");
        return;
        }
  }
  
fclose(mon.TapeSave);

sprintf(ch2,"%s/%s",mon.TapeDir,ch);

if ((!(f=fopen(ch2,"a+b")))||(ch2[0]=='\0'))
      { 
      printf("** Unable to create file !\n");
      mon.TapeSave=NULL;
      return;
      }
 else 
       {
       strcpy(mon.TapeSaveName,ch);
       fclose(f);fclose(mon.TapeSave);
       printf("Current save tape is now %s\n",mon.TapeSaveName);
       }

mon.TapeSave=fopen(ch2,"wb");
 
}       

/****** entre dans le mode moniteur ********/

void EnterMonitorMode()

{
SetBreakpointsInactive();
}

/****** sort du le mode moniteur ********/

void ExitMonitorMode()

{
WaitReleased(XK_Return);

RefreshDisplay(); 
SetBreakpointsActive();
}

/****** affiche les registres *************/

void PrintRegisters()

{
printf("A = %x ; X = %x ; Y = %x ; PC = ",A,X,Y);
PrintAddress(PC);
printf("\nS = %x ; P = %x\n",S,P);

printf("P : N=%d;V=%d;B=%d;D=%d;I=%d;Z=%d;C=%d\n\n",
         ((int)(P&0x80))>>7,((int)(P&0x40))>>6,((int)(P&0x10))>>4,((int)(P&0x8))>>3,
         ((int)(P&0x4))>>2,((int)(P&0x2))>>1,P&0x1);
}

/********** Rembobine le fichier *****************/

int RewindTapeLoad()
{

 if (mon.TapeLoadName[0]=='\n') 
   return 0;

   rewind(mon.TapeLoad);
   return 1;
}

/****** affiche l'instruction courante *************/

void PrintCurrentInstruction()

{
char ch[20],ch2[20];

Disass(PC,ch,M);
strcpy(ch2,HexNumber(PC,1));
printf("%s : %s\n",ch2,ch);
}

/****** affiche une adresse ***************/

void PrintAddress(unsigned short int re)

{
/*char ch[10];*/
int i;

putchar('$');

if (re<0x0010) printf("000"); else
   if (re<0x0100) printf("00"); else
      if (re<0x1000) putchar('0');
 
/*sprintf(ch,"%x",re);
for (i=0;i<strlen(ch);i++)
 if ((ch[i]>='a')&&(ch[i]<='f')) putchar(ch[i]-('a'-'A')); else putchar(ch[i]);*/

printf("%X",re);
 
}

/****** affiche une adresse en binaire ***************/

void PrintBinary(unsigned long int re)

{
int i,nbcar=0;
unsigned long int dec;

dec=re;
putchar('%');

if (!re) {printf("00000000");return;}

do
 {
 dec=dec>>1;
 nbcar++;
 } 
 while (dec);
 
 for (i=nbcar;i<8;i++) putchar('0');
 
 dec=re;
 
do
 {
 if (dec&re) putchar('1'); else putchar('0');
 dec=dec>>1;
 nbcar++;
 } 
 while (dec);
 
 
}

/******* renvoie la valeur hexa d'une chaine de caracteres *********/

unsigned short int ValeurHexa(str)

char *str;

{
unsigned int resu;
char str2[10];

strcpy(str2+2,str);
str2[0]='0';
str2[1]='x';

sscanf(str2,"%x",&resu);

return ((unsigned short)resu);
}

/******** affiche illegal instruction *****/

void PrintIllegalInstructionMessage()

{
printf("Illegal Instruction at ");PrintAddress(PC);
printf(" OP Code $%x\n",M[PC]);
}

/******** edition memoire **********/

void MemoryEditMode(opcode)

unsigned short int opcode;

{
char ch[100],*ch2,nb[8];
unsigned char vh;

printf("Enter hex bytes,separated by ' '.Type Return to Validate\nReturn with empty input exits\n");


 for (;;)
 {
  PrintAddress(opcode);printf(" : ");fflush(stdout);
  gets(ch);
  if (mon.BreakReq)
                   {
                   printf("\n** Break\n");
                   mon.BreakReq=0;
                   return;
                   }

  ch2=ch;

  while(((*ch2)!='\0')&&((*ch2)==' ')) ch2++; /* vire les espaces */

  if ((*ch2)=='\0') return;


  for (;;)

   {
   sscanf(ch2,"%s",nb);vh=(unsigned char)ValeurHexa(nb);

   if (opcode<0xC000) Place(vh,opcode); else M[opcode]=vh;
   opcode++;
 
   while(((*ch2)!='\0')&&((*ch2)!=' ')) ch2++; /* recherche un espace */
   if ((*ch2)=='\0') break;
   while(((*ch2)!='\0')&&((*ch2)==' ')) ch2++; /* vire les espaces */
   if ((*ch2)=='\0') break;
  
   }
   RefreshDisplay();
 }   
   
}

/******** desassemblage **********/

void DisassembleMode(unsigned short int ADR)

{
char ch[20],ch2[20];
int nb_inst;

mon.BreakReq=0;

printf("CTRL-C or 'b'\n");

 for (;;)
 {
 nb_inst=Disass(ADR,ch,M);
 strcpy(ch2,HexNumber(ADR,1));
 printf("%s : %s",ch2,ch);fflush(stdout);gets(ch2);
 if ((mon.BreakReq)||(ch2[0]=='b'))
                   {
                   printf("\n** Break\n");
                   mon.BreakReq=0;
                   return;
                   }
                   
 if (IsBreakSequence(ch)) printf("--------------------\n");
 ADR+=nb_inst;if (!nb_inst) ADR++;  
 }   
   
}

/******** affiche le prompt et demande une chaine ********/

int MonitorPrompt()

{
char ch[LG_CMD];

printf("PC=");PrintAddress(PC);printf(" Ready.\n");

for (;;)
{
printf("> ");fflush(stdout);
gets(ch); 
if (mon.BreakReq)  
                   {
                   mon.BreakReq=0;
                   if (Ask("\nDo you really want to exit")||mon.BreakReq)
                     {
                     printf("\n** Exiting...\n");
                     ExitEmulator();
                     }
                   }
else return(MonitorInterpreter(ch));
}

}


/**** Memory Dump *****/

void DumpMemory(unsigned short int debut,unsigned short int fin)

{
unsigned short int i,j,k,re;
unsigned char l;
unsigned long m;

k=(fin-debut)/OPL+1;

for (i=0;i<k;i++)
 {
 re=debut+OPL*i;
 putchar('\n');
 PrintAddress(re);printf(" : ");
 
 for (j=0;j<OPL;j++)
   {
   m=debut+i*OPL+j;
   if (m>0xFFFF) break;
   l=M[m];
   if (l<0x10) putchar('0'); 
   printf("%x ",(int)l);
   }
   printf("    ");if (m>0xFFFF) break;

 for (j=0;j<OPL;j++)
   {
   m=debut+i*OPL+j;
   if (m>0xFFFF) break; 
   l=M[m];
   if ((l>=32)&&(l<=127)) putchar(l); else putchar(' '); 
   }
   if (m>0xFFFF) break;  
 }
printf("\n"); 
}

int MonitorMode(ms)

int ms;
{
int i,OLD_PC,OLD_S;
char c;

switch (ms)

 {
 case ILLEGAL_INSTRUCTION :
      if (!mon.illeg_inst) {PC++;return NEXT_INSTRUCTION;}
      EnterMonitorMode();
      PrintIllegalInstructionMessage();
      return (MonitorPrompt());      
      
 case BREAKPOINT :
      EnterMonitorMode();
      if (!TestBreakpointValid(PC)) 
                {
                PrintIllegalInstructionMessage();
                return (MonitorPrompt());      
                }
                
      /* sinon */
      
      printf("Breakpoint at ");PrintAddress(PC);putchar('\n');
      return (MonitorPrompt());      

 case USER_BREAK :
      EnterMonitorMode();
      mon.BreakReq=0;
      printf("User Break\n");
      return (MonitorPrompt());      

 case MONITOR_COMMAND :
      return (MonitorPrompt());

 case STEP_COMMAND :

      i=RemoveBreakPoint(PC);OLD_PC=PC;                   

      ExitMonitorMode();
      if (ReadInstruction()==ILLEGAL_INSTRUCTION)  PrintIllegalInstructionMessage();
      EnterMonitorMode();      

      if (i) AddBreakPoint(OLD_PC);                   

      PrintRegisters();
      PrintCurrentInstruction();
      return (MonitorPrompt());      

 case STEP_OVER_COMMAND :

        i=RemoveBreakPoint(PC);OLD_PC=PC;

        ExitMonitorMode();
        
      if (M[PC]==0x20) 
        {
        OLD_S=S;
        ReadInstruction();

         while(OLD_S!=S)
         {
         if (mon.BreakReq)
                 {
                 printf("\n** User Break\n");
                 mon.BreakReq=0;
                 RefreshDisplay();
                 break;
                 }
         
          if (ReadInstruction()==ILLEGAL_INSTRUCTION)  
                    {  
                    PrintIllegalInstructionMessage();
                    RefreshDisplay();
                    break;
                    }
          }
        
        }      
        else
        {                              
        if (ReadInstruction()==ILLEGAL_INSTRUCTION)  PrintIllegalInstructionMessage();
        }
        
      EnterMonitorMode();            
      if (i) AddBreakPoint(OLD_PC);
                         
      PrintRegisters();
      PrintCurrentInstruction();
      return (MonitorPrompt());      


 case EXIT_MONITOR_MODE :
      printf("Returning to Oric...\n");
      ExitMonitorMode();
      
      return NEXT_INSTRUCTION;      

 case EXIT_EMULATOR :
      printf("Exiting Oric Emulator.\n");
      ExitEmulator();
      
 case RESET_EMULATOR :
      printf("Resetting Oric Emulator.\n");
      RewindTapeLoad();
      ExitMonitorMode();
      ResetOric();
      return NEXT_INSTRUCTION;

 case USER_RESET1 :
      printf("Reset Key Pressed. Jump to NMI Routine\n");
      RewindTapeLoad();
      PC=0x247;
      M[0x30E]=0xC0;
      return NEXT_INSTRUCTION;      

 case USER_RESET2 :
      printf("Deprotected Reset Key Pressed. Jump to NMI Routine\n");
      RewindTapeLoad();
      PC=0xF8B2;M[0x1A]=0x4C;M[0x1B]=0xB0;M[0x1C]=0xCC;
      M[0x30E]=0xC0;
      return NEXT_INSTRUCTION;      

 case CHANGE_TAPE :
      EnterMonitorMode();
      ChangeTapeLoad(NULL);
      ExitMonitorMode();
      return NEXT_INSTRUCTION;      

 case PATCH_OUTBYT :
      EcrireOctet(A);
      return RTS();      
 
 case PATCH_RDBYTE :
      switch(LireOctet(&c))
       {
       case 0 : 
        printf("** No tape specified. Press F2 for warm reset...\n");
        LDA(0);
        return RTS();      
       case 2 :
        printf("** End of tape. ");
        if (Ask("Do you want to change tape (y) or to reset (n)")) 
                          {ChangeTapeLoad("");return NEXT_INSTRUCTION;}
                      else RewindTapeLoad();
        LDA(0);
        return RTS();
       case 1 : LDA(c);
                break; /* c'est ok */      
       }        
       
      return RTS();      

 
 case PATCH_SYNC :
            
  while (1)
    {
      switch(LireOctet(&c))
       {
       case 1 : break; /* c'est OK */      
       case 0 : 
        printf("** No tape specified. Press F2 for warm reset...\n");
        PC++;
        return NEXT_INSTRUCTION;
       case 2 :
        printf("** End of tape. ");
        if (Ask("Do you want to change tape (y) or to reset (n)\n")) 
                                   {ChangeTapeLoad("");return NEXT_INSTRUCTION;}
        if (mon.TapeLoad) rewind(mon.TapeLoad);
        PC=M[0xFFFA]+((int)M[0xFFFB]<<8);
        M[0x1A]=0x4C;M[0x1B]=0xB0;M[0x1C]=0xCC;
        M[0x30E]=0xC0;
        mon.dispmode=TEXT;
        return NEXT_INSTRUCTION;
       } 
     if (c==0x16) break;  /** condition d'arret de synchro **/ 
     }       
      X=0;RefreshDisplay();
       
      return RTS();  

 case PATCH_PRINT :
     if (mon.printer_file) fputc((char)A,mon.printer_file);
     return RTS();  
     
 }
 printf("Rhaaa!\n");
 return NEXT_INSTRUCTION;
}
 
 
 
 
 
