/***************************************************************************/
/**                                                                       **/
/**                 The ORIC 48K emulator.UNIX version                    **/
/**                                                                       **/
/**                Written by JF FABRE (fabre@supaero.fr)                 **/
/**                                                                       **/
/**                This program may be freely distibuted                  **/
/**                                                                       **/
/**             as long as this header is included unmodified             **/
/**                                                                       **/
/***************************************************************************/

/* Main program */

#include "protos.h"
/*#include <sys/audio.h>*/

unsigned short int PC;
unsigned char S,X,A,Y,P;
unsigned char *M;
unsigned char NC;

Monitor_struct mon;
comm_struct cs;
                             
                             
extern ecran disp;

/********** Lecture de la ROM et Patches **********/

void InitROM()

{
FILE *f;

if (!M) M=(unsigned char *)malloc(0x10000*sizeof(char));

/*** chargement de la ROM ***/

if (!(f=fopen("Atmos.ROM","rb"))) 

   {
   printf("** Atmos.ROM : File not found\n");
   exit(1);
   }
   
  fread(M+0xc000, 1, 0x4000, f);
  
  fclose(f);

/*** Patches pour certaines fonctions systeme ***/

/*** trap ecriture clavier ***/

/*M[J_PROV_KB3]=0x07;
M[J_PROV_KB2]=0xEA;
M[J_PROV_KB2+1]=0xEA;
M[J_PROV_KB2+2]=0xEA;*/

/*** sons ***/

M[J_PING]=0xFF;
M[J_SHOOT]=0xFF;
M[J_EXPLODE]=0xFF;
M[J_ZAP]=0xFF;
M[J_KBBEEP]=0x60;
M[J_CONTBP]=0x60;
M[J_MUSIC]=0xFF;
M[J_PLAY]=0xFF;
M[J_SOUND]=0xFF;

/*** magneto ***/

M[J_RDBYTE]=0x27;
M[J_OUTBYT]=0x27;
M[J_SYNC]=0x27; /* le disque est toujours synchro */
M[J_SYNC+1]=0x4C;
M[J_SYNC+2]=(J_SYNC+1)&0xFF;
M[J_SYNC+3]=(J_SYNC+1)>>8;   /* faire reboucler au cas ou ...*/
M[J_OUTCHR]=0x27; /* imprimante */

/*** hires/text ***/

M[J_RETURN_INIT]=0x37;
M[J_RETURN_HIRES]=0x37;

/*** patch pour skipper un test inutile de la RAM ***/


M[0xFA4F]=0x55;
M[0xFA50]=0x4C;
M[0xFA51]=0x57;
M[0xFA52]=0xFA;


/** si tu decommentes ces lignes,le wait ne marche plus, c'est trop non ? **/

/*
M[0xEECF]=0xA9;
M[0xEED3]=0xA9;
*/
  
}

/********* CTRL-C ************/

void BreakSignal()

{
mon.Mon_Status=USER_BREAK;
signal(SIGINT,BreakSignal);
mon.BreakReq=1;
}

/******** reset *********/

void ResetOric()

{
mon.dispmode=TEXT;
/*M[0x30D]=0x40;*/
M[0x306]=0xFF;
M[0x307]=0xFF;
PC=(int)M[0xFFFC]+((int)M[0xFFFD]<<8);
}

/***** programme principal ******/

void main()

{
register int i;
int j;
XEvent evenem;
FILE *f;
register int R3,R4=3;
char ch[40],ch2[200],T1=0;

InitFonctions();


/*** init du CPU ***/

printf("Loading ROM...\n");

InitROM();


/****** lecture des preferences *********/
   
if (!ReadPreferences(&mon)) printf("Using default preferences.\n");
printf("Preferences loaded.\n");
PrintPreferences(mon);

/******* ouverture du fichier imprimante *******/

mon.printer_file=fopen("printed.bas","wt");
if (!mon.printer_file) printf("No printing possible...\n");


/****** lecture des correspondances clavier et init *********/
   
printf("Loading Keycodes...\n");

InitKeyboard();


/*** Ouverture de l'audio si possible ***/

#ifdef AUDIO_DESCRIBE

printf("Starting Audio...\n");

if (!OpenAudioDevice(16000,0)) {
                               mon.sound=0;
                               printf("Audio not started.\n");
                               }
                               else
                               {
                               if (InitAudioProcess(&cs)) printf("Audio started.\n");
                                                     else printf("Audio not started.\n");
                               }

#endif
   
/*** update de la ROM ***/

/*
M[0xEDB4]='9';
M[0xEDB5]='4';
*/

/**********************/

X=0;
Y=0;
A=0;
P=0x2; /* Z=1 */
S=0xFF; /* inutile car la ROM le fait */

ResetOric();

/******/

InitOricScreen(0,NULL);
signal(SIGINT,BreakSignal);

mon.Mon_Status=MONITOR_COMMAND;

mon.nb_break=0;
mon.nb_mwWM=0;
mon.nb_mwRM=0;
mon.interrupt=1;
mon.affiche=1;

strcpy(mon.LastCmd,"go");


 while (1)
  { 
       if ((XEventsQueued(disp.dpy,QueuedAfterReading)==0)) 
       { 

       XFlush(disp.dpy);
       }
          
      
    else 
         {
         XNextEvent(disp.dpy,&evenem);
                  
         switch(evenem.type) 
            { 
              case Expose:
                   if (mon.autorefresh) RefreshDisplay();                    
               break; 
 
             } 
           } 
   
   for (j=0;j<70;j++)
   {
    XQueryKeymap(disp.dpy,disp.schem_clav); /** lire le clavier **/
    ControlKeys();
    
    for (i=0;i<30000;i++)
    {   
    if (mon.Mon_Status==NEXT_INSTRUCTION)
              {
              mon.Mon_Status=(**(PFONCT[M[PC]]))(); /* modifie NC */

              R3=(unsigned short int)M[0x308];
              if (R3||(M[0x309]))
              {
              R3-=NC;
              M[0x308]=(unsigned char)R3;                                                   
               if (R3<0) 
                 {                 
                 if (!(--M[0x309])) 
                   {
                   M[0x308]=0x0;
                   M[0x30D]=0x20;
                   T1=1;
                   }
                 } 
              }
              
              R3=(unsigned short int)M[0x304];
              if ((R3)||(M[0x30B]&0x40)||(M[0x305]))
              {
              R3-=NC;
              
              M[0x304]=(unsigned char)R3;                                                   
               if (R3<0) 
                 {                 
                 if (!(--M[0x305])) 
                   {
                   if (M[0x30B]&0x40)
                     {
                     M[0x304]=M[0x306];
                     M[0x305]=M[0x307];
                     }
                   M[0x30D]=0x40;
                   T1=1;
                   }
                 }
               }
               

              if ((T1)&&(mon.interrupt))  
                if (((M[0x30E]&M[0x30D]))&&(M[0x30E]&0x80))
              
                 {
                  T1=0;
                  if (!(P&0x4))
                                                    
                                 {
                                 /** si interruptions masquees ne fait rien **/
                                 IRQ();                                 
                                 /*break;*/
                                 }
                  }
                  
              } 

               
         else mon.Mon_Status=MonitorMode(mon.Mon_Status);
       }
            
   
      }

   }
         
}
