/***************************************************************************/
/**                                                                       **/
/**                 The ORIC 48K emulator.UNIX version                    **/
/**                                                                       **/
/**                Written by JF FABRE (fabre@supaero.fr)                 **/
/**                                                                       **/
/**                This program may be freely distibuted                  **/
/**                                                                       **/
/**             as long as this header is included unmodified             **/
/**                                                                       **/
/***************************************************************************/

/* Functions prototypes */

#include "defs.h"

/** fichier inout.c **/

void CurrentContext(unsigned short int,unsigned char,contx*);
void CurrentPaper(unsigned short int,unsigned char,contx *);
int TypeDonnee(unsigned char);
void Place(unsigned char,unsigned short int);
void AfficheFinLigne();
void EcritureEcranText(unsigned char,unsigned short int);
void EcritureEcranHires(unsigned char,unsigned short int);
void AfficheFinLigneText(unsigned short int,unsigned char,unsigned char,contx*);
void AfficheFinLigneTextPart(unsigned short int,unsigned char,unsigned char,contx*);
void AfficheFinLigneHires(unsigned short int,unsigned char,unsigned char,contx*);
void AfficheFinLigneHiresPart(unsigned short int,unsigned char,unsigned char,contx*);

/** fichier gestionX.c **/

int AllouerCouleur(unsigned int,unsigned int,unsigned int);
void AfficheCaractere(unsigned char,unsigned char,unsigned char,contx*,unsigned short int);
void AfficheOctetHires(unsigned char,unsigned char,unsigned char,contx*);
void InitOricScreen(unsigned int,char**);
void BouclePrincipale();
void RefreshDisplay();
void ClearScreen();

/** fichier CPU6502.c **/

int ReadInstruction();
void InitFonctions();
int TrapOPCode();
T_PFONCT PFONCT[256];
int BRK();  /* pour etre utilise dans oric.c */

/** fichier monitor.c **/

void DumpMemory(unsigned short int,unsigned short int);

int MonitorMode(int);

int MonitorPrompt();

int AddElt(unsigned short int,unsigned short int *,unsigned char *,int *);
int RemoveElt(unsigned short int,unsigned short int *,int *);
int TestEltValid(unsigned short int,unsigned short int *,int *);

int AddBreakPoint(unsigned short int);
int RemoveBreakPoint(unsigned short int);
int TestBreakpointValid(unsigned short int);
int AddMemWatchRM(unsigned short int);
int RemoveMemWatchRM(unsigned short int);
int TestMemWatchRMValid(unsigned short int);
int AddMemWatchWM(unsigned short int);
int RemoveMemWatchWM(unsigned short int);
int TestMemWatchWMValid(unsigned short int);


void ListBreakpoints();
void DeleteBreakpoints();
void SetBreakpointsActive();
void SetBreakpointsInactive();

void ListMemWatchesWM();
void ListMemWatchesRM();
void DeleteMemWatchesWM();
void DeleteMemWatchesRM();

void PrintAddress(unsigned short int);
void PrintBinary(unsigned long int);
void PrintRegisters();
void PrintStatus(char *,int);
void PrintExpression(char *);
void PrintCurrentInstruction();
void PrintIllegalInstructionMessage();

void EnterMonitorMode();
void ExitMonitorMode();

void EditMemoryMode(unsigned short int);
void DisassembleMode(unsigned short int);

unsigned short int Caller();

unsigned short int ValeurHexa(char *);

void ChangeTapeLoad(char *);
void ChangeTapeSave(char *);

/** fichier mcli.c **/

int MonitorInterpreter(char *);
int ReadHexBytes(char *,char *);

/** fichier estime.c **/

int EvaluateExpression(char *,char *);

/** fichier oric.c **/

void BreakSignal();
void ResetOric();
void InitROM();
void ExitEmulator();

/** fichier assembler.c **/

int IsBreakSequence(char *);
int Disass(unsigned short int,char *,unsigned char *);
char *HexNumber(unsigned short int,unsigned short int);

/** fichier sons.c **/

unsigned int LoadSoundFile(char *,son *);
void ChargerSons();
int OpenAudioDevice(int,int);
void PlaySound(son);


/*** keyboard.c ***/

void InitKeyboard();
void ControlKeys();
int ToucheAppuyee(unsigned long int);
void WaitReleased(int);

/*** prefs.c ***/

void PrintPreferences(Monitor_struct);
int ReadPreferences(Monitor_struct *);
void PrintStatus(char *,int);
int Ask(char *);
