/***************************************************************************/
/**                                                                       **/
/**                 The ORIC 48K emulator.UNIX version                    **/
/**                                                                       **/
/**                Written by JF FABRE (fabre@supaero.fr)                 **/
/**                                                                       **/
/**                This program may be freely distibuted                  **/
/**                                                                       **/
/**             as long as this header is included unmodified             **/
/**                                                                       **/
/***************************************************************************/

/* Setup program */

#include <stdio.h>
#include "defs.h"

void sortie()

{
printf("Bye...\n");
exit(0);
}

/** Sauver la configuration **/

void SaveConfig(Monitor_struct mon)

{
FILE *f;

if (!(f=fopen("oric.cfg","wt"))) {printf("** oric.cfg : file creation error\n");exit(1);}

fprintf(f,"%s\n",mon.TapeLoadName);
fprintf(f,"%s\n",mon.TapeDir);
fprintf(f,"%s\n",mon.DumpDir);
fprintf(f,"%d\n",mon.sound);
fprintf(f,"%d\n",mon.illeg_inst);
fprintf(f,"%d\n",mon.autorefresh);
fprintf(f,"%s\n",mon.KeybFileName);

fclose(f);
printf("Config file save as oric.cfg.\nType 'oric' to run the emulator.\n\n");
}
/****** programme de setup *******/

main()

{
FILE *f;
Monitor_struct mon;
char ch[LG_CMD];

printf("\nOric Atmos Emulator V3.0 configuration program...\n\n");

if (!ReadPreferences(&mon)) printf("Config file not found...\n");
                   else printf("Preferences loaded...\n");

PrintPreferences(mon);

if (Ask("Is this correct")) sortie();

printf("\nModifying configuration...\n");

for(;;)
{
printf("\n     1 to change default tape.\n");
printf("     2 to change default tape directory.\n");
printf("     3 to change default dump directory.\n");
printf("     4 to change default keyboard file.\n");
printf("     5 to change default sound on/off.\n");
printf("     6 to change default illegal trapped on/off.\n");
printf("     7 to change default autorefresh on/off.\n\n");
printf("     q to quit without saving configuration.\n     s to quit and save\n\n");
fflush(stdout);

ch[0]='\0';

while(ch[0]=='\0')
  {
  printf(" ? ");fflush(stdout);gets(ch);
  switch(ch[0])
    {
    case '1' : printf("\nType in new tape name : ");fflush(stdout);gets(mon.TapeLoadName);break;
    case '2' : printf("\nType in new tape directory name : ");fflush(stdout);gets(mon.TapeDir);break;
    case '3' : printf("\nType in new dump directory name : ");fflush(stdout);gets(mon.DumpDir);break;
    case '4' : printf("\nType in new keyboard filename : ");fflush(stdout);gets(mon.KeybFileName);break;
    case '5' : mon.sound^=1;printf("\nSound is now ");fflush(stdout);PrintStatus(mon.sound);break;
    case '6' : mon.illeg_inst^=1;printf("\nIllegal trapped is now ");fflush(stdout);PrintStatus(mon.illeg_inst);break;
    case '7' : mon.autorefresh^=1;printf("\nAutorefresh is now ");fflush(stdout);PrintStatus(mon.autorefresh);break;
    case 'q' : sortie();
    case 's' : SaveConfig(mon);sortie();
    default  : ch[0]=='\0';
    }
  }
}

}  
